<template>
  <v-container fill-height>
    <v-layout row wrap align-center>
      <v-flex xs6 sm6 offset-sm3>
        <v-card>
          <v-card-title primary-title>
            <v-tabs fixed icons centered>
              <v-tabs-bar color="white">
                <v-tabs-slider color="cyan"></v-tabs-slider>
                <v-tabs-item href="#create-tab">
                  <v-icon>create</v-icon>
                  Create Account
                </v-tabs-item>
                <v-tabs-item href="#forgot-tab">
                  <v-icon>account_circle</v-icon>
                  Forgot Password
                </v-tabs-item>
              </v-tabs-bar>
              <v-tabs-items>
                <v-tabs-content :id="'create-tab'" >
                  <v-card flat>
                    <v-card-title>
                      <span>
                        Enter your UT Dallas NetId and we'll send you an email with
                        a link to setup your account
                      </span>
                    </v-card-title>
                    <v-card-text>
                      <v-form v-model="createform">
                        <v-text-field
                              label="NetId"
                              v-model="netid"
                              :rules="netidRules"
                              :help="abc1234567"
                              required
                              ></v-text-field>
                      </v-form>
                    </v-card-text>
                    <v-card-actions>
                      <v-btn
                              @click="create"
                              :disabled="!createform"
                              >
                              Create Account
                      </v-btn>
                    </v-card-actions>
                  </v-card>
                </v-tabs-content>

                <v-tabs-content :id="'forgot-tab'" >
                  <v-card flat>
                    <v-card-title>
                      <span>
                        Forgot your password? Enter your netId and a link will
                        be sent to your UTDallas email account.
                      </span>
                    </v-card-title>
                    <v-card-text>
                      <v-form v-model="forgotform">
                        <v-text-field
                              label="NetId"
                              v-model="netidForgot"
                              :rules="netidRules"
                              :help="abc1234567"
                              required
                              ></v-text-field>
                      </v-form>
                    </v-card-text>
                    <v-card-actions>
                      <v-btn
                              @click="forgot"
                              :disabled="!forgotform"
                              >
                              Send Reset Link
                      </v-btn>
                    </v-card-actions>
                  </v-card>
                </v-tabs-content>

              </v-tabs-items>
            </v-tabs>
          </v-card-title>
          <v-snackbar top :timeout="timeout" v-model="errorSnackbar" color="error" >
            {{ errorText }}
          </v-snackbar>

            <v-snackbar top :timeout="timeout" v-model="successSnackbar" color="success" >
              {{ successText }}
            </v-snackbar>

        </v-card>
      </v-flex>
    </v-layout>
  </v-container>


</template>

<script>
import axios from 'axios';

export default {

  data: () => ({
    forgotform: true,
    passwordHidden: true,
    timeout: 6000,
    loginform: true,
    createform: true,
    uid: '',
    password: '',
    netid: '',
    netidForgot: '',
    errorSnackbar: false,
    successSnackbar: false,
    errorText: '',
    successText: '',
    netidRules: [
      v => !!v || 'NetId is required',
      v => /^[a-z]{3}[0-9]{6}$/.test(v) || 'NetId must be valid',
    ],
  }),
  methods: {
    forgot() {
      axios.post('/api/forgot', {
        netid: this.netId,
      }).then(() => {
        this.successText = 'Success! Check your email to reset your password';
        this.successSnackbar = true;
      }).catch(() => {
        this.errorText = 'Oops! An error occurred. Please try again later.';
        this.errorSnackbar = true;
      });
    },
    create() {
      axios.post('/api/register', {
        netid: this.netId,
      }).then(() => {
        this.successText = 'Success! Check your email for instructions.';
        this.successSnackbar = true;
      }).catch(() => {
        this.errorText = 'Oops! An error occurred. Please try again later.';
        this.errorSnackbar = true;
      });
    },
  },
};
</script>

<style scoped>
</style>
